concrete coreGer of core =  open Prelude, TypesGer, ResourceGer, internalOperGer, myTypesGer, myResourceExtGer, externalOperGer, ParadigmsGer, PredicationGer, ResourceExtGer, ExtraGer, AtomGer, formatOCL in {

--# -path=.:abstract:prelude:german:ExtraGer
--# -optimize=all

lincat 
    Class = ClassL;
    Sent = S;
    AtomSent = AS;
    Instance = Inst;
    Subtype = SubtypeL;
    ClassConstraintBody = ClassConstraintBodyL;   
    OperConstraintBody = OperConstraintBodyL;   
    SentIter = SentIterL;
    InstIter = InstIterL;
    Constraints = ConstraintL;
    Document = DocumentL;
    AndList = AndListL;
    OrList = OrListL;
    SumList = SumListL;
    ProductList = SumListL;
    LetDef = LetDefL;
    LetDefSent = LetDefSentL;
    LetDefList = LetDefListL;
    CollList = ListNP;


--
-- Properties
--
    SimpleProperty = CN;
    BooleanProperty = CN;
    OnProperty = CN;
    IsProperty = AP;
    StaticProperty = CN;
    AssocProperty = CN;


printname
    coerce = "[in Obertyp umwandeln]";

lindef Instance = \str -> constNoInfl (mkItalic str);

lin testNP = {s = (appFun1 (funGenCN (UseN (nHand "Mutter" "Mtter"))) (DefOneNP (UseN (nVater "Sohn" "Shne")))).s!NPCase Nom };

--
-- Sentences 
--
    atPreSent s = {s = (table{ c => s.s!c ++ ["zum Beginn der Operation"]}); lock_S = <>}; -- This is a cheat! Solution depends on Sentences consisting of their parts which would be huge change to the resource grammars

    negAtom a = negAS a;
    posAtom a = posAS a;


--
-- Subtyping 
--
    coerce sub super proof obj = obj;
    subTypeTrans : (a, b, c : ClassL) -> SubtypeL -> SubtypeL -> SubtypeL = 
	\a, b, c, pab, pbc -> {s = ["Jedes"] ++ a.s!Weak!Sg!Nom ++ ["ist ein"] ++ c.s!Weak!Sg!Nom ++ "," 
    	++ "da" ++ pab.s ++ "und" ++ pbc.s}; 
    subTypeRefl : (c : ClassL) -> SubtypeL = \a -> {s = "ein" ++ a.s!Weak!Sg!Nom ++ ["ist ein"] ++ a.s!Weak!Sg!Nom};  


--
-- Instances
--

    eq _  = equalTo;
    neq _ = notEqualTo;	
    atPre _ i = np2inst (appFun1 (funVonCN (ModAdj previousAP (UseN valueN))) (inst2np i));

--
-- self & result
--
    self c _ = np2inst (DefOneNP (class2cn c));
    result _ _ = np2inst (DefOneNP (UseN resultN));


--
-- pre- and postconditions
--

    emptyOperC = {s0,s1 = ""; preC, postC = E0};
    emptyClassC = {s0,s1 = ""; invC, defC = E0};
    emptyPostC = PredVP (DefOneNP (UseN operationN)) (AdvVP (PosVG (PredV terminateV)) normallyAdV);



-- The following are cheats, they use Types and are just Str, no Sentence
    defC _ ld cs = {
        s0 = cs.s0;
        s1 = mkBullet ++ ld.s0 ++ ["ist definiert als"] ++ ld.s1 ++ cs.s1;
        invC = cs.invC;
        defC = eNext cs.defC};
    defSentC ld cs = {
        s0 = cs.s0;
        s1 = mkBullet ++ ld.s0 ++ ["genau dann wenn"] ++ ld.s1 ++ cs.s1;
        invC = cs.invC;
        defC = eNext cs.defC};
    invC i cs = {
	s0 = mkBullet ++ i.s!Main ++ cs.s0; 
        invC = eNext cs.invC;
        s1 = cs.s1; 
	defC = cs.defC;
    };
    invCt i  = {
	s0 = i.s!Main; 
        invC = E1;
        s1 = "";
	defC = E0;
    };

    preC p cs = 
        {s0 = mkBullet ++ p.s!Main ++ cs.s0; 
         s1 = cs.s1; 
         preC = eNext cs.preC; 
         postC = cs.postC;
        };
    postC p cs = 
        {s0 = cs.s0; 
         s1 = mkBullet ++ p.s!Main ++ cs.s1; 
         preC = cs.preC;
         postC = eNext cs.postC;
        };
    prepostCt precond postcond = 
        {s0 = precond.s!Main;
         s1 = postcond.s!Main;
         preC = E1;
         postC = E1;
        };
        
    invHC s = {s = s.s!Main};

--
-- let-definitions
--

-- the Inst-returning let-defs work just as implicit property calls,
-- which means we duplicate code from useXPropertyImplicit lins
lin letSimpleProperty rec ret prop definiens = letNoArg
        (np2inst (DefOneNP prop))
        definiens;
    letOnProperty rec ret prop definiens = letNoArg
        (np2inst (DefOneNP prop))
        definiens;
    
    -- Person::isMarried() -- a person is married 
    letIsProperty rec prop definiens = letNoArgSent
        (posAS (mkPred (inst2np (IndefOneNP (class2cn rec))) (PredAP prop)))
        definiens;
    letBooleanProperty rec prop definiens = letNoArgSent
        (posAS (mkPred (DefOneNP (ModAdj propertyAP prop)) (PredV holdV)))
        definiens;

    letAddArg c d boundLetDef = boundLetDef;
    letAddArgSent c boundLetDefSent = boundLetDefSent;
    
    typeFormalParam clss exp = exp; -- has effect only in OCL

    nilLet = {s= ""; length = E0};
    consLet _ ld lds = {
        s = (mkBullet ++ ld.s0 ++ ["ist definiert als"] ++ ld.s1 ++ lds.s);
        length = eNext lds.length
    };
    consLetSent ld lds = {
        s = (mkBullet ++ ld.s0 ++ ["genau dann wenn"] ++ ld.s1 ++ lds.s);
        length = eNext lds.length
    };
    
    localLet letdefs sent = { -- FIXME:
	s = table {
		Main => ((case letdefs.length of {
				E1 => "Benutze die folgende Definition"; 
				_ => "Benutze die folgenden Definitions"}
			)
			++ wrapBullets letdefs.s ++ ["in:"] ++ sent.s!Main);
		_ =>	nonExist
	};
	lock_S=<>
    };


--
-- list of constraints
-- 

    oneConstraint c = c;
    consConstraint c cs = {s = c.s ++ mkDivide ++ cs.s};
    document cs = {s = (mkFormatHeader (mkTitle ("OCL" ++ "Constraints"))
        (mkHeading ("OCL" ++ "Constraints")) (mkStyle "OCLstyle.css"))
        ++ cs.s ++ mkFormatFooter};

--
-- Properties
--
    -- Linearized as: "the prop of the obj"
    useSimpleProperty _ _ prop obj = np2inst(appFun1 (funGenCN prop) obj);
 
    -- Linearized as: "the prop"
    useSimplePropertyImplicit _ _ prop obj = np2inst (DefOneNP prop);
	    	
    -- Linearized as: "the prop on obj is true"
    useBooleanProperty _ prop obj = 
        mkPred (instFunAnCN prop obj) (PredAP trueAP);
        
    -- Linearized as: "the prop is true"
    useBooleanPropertyImplicit _ prop obj = 
	     mkPred (DefOneNP prop) (PredAP trueAP);	     
	    
    -- Linearized as: "the prop on obj"
    -- E.g. "the query x on y"
    useOnProperty _ _ prop obj = instFunAnCN prop obj;
    
    -- Linearized as: "the prop"
    useOnPropertyImplicit _ _ prop obj = np2inst (DefOneNP prop);	    	    
            
    -- Handle cases like isMarried
    useIsProperty _ prop obj = 
        mkPred (inst2np obj) (PredAP prop);
        
    -- Handle cases like isMarried
    -- No difference between useIsProperty and useIsPropertyImplicit.
    -- Object always has to be mentioned.
    useIsPropertyImplicit _ prop obj = 
        mkPred (inst2np obj) (PredAP prop);
        
    -- For properties described using text.
    -- Linearized as: "the prop (specified in obj)"
    useStaticProperty _ _ prop obj = 
        np2inst (DefOneNP (parenthCN 
        prop (ap2s (ComplAdj specifiedInAdj2 obj))));
        
    -- Linearized as: "the prop" 
    useStaticPropertyImplicit _ _ prop obj = np2inst (DefOneNP prop);
	  
    -- For associations
    -- Linearized as: "the set of prop associated with obj"
    useAssocProperty _ _ prop obj = 
        np2inst (appFun1 (funGen setN) (IndefManyNP 
        (ModAdj (ComplAdj associatedWithAdj2 (inst2np obj)) prop)));
        
    -- Linearized as: "the set of prop" 
    useAssocPropertyImplicit _ _ prop obj = 
        np2inst (appFun1 (funGen setN) (IndefManyNP (prop)));    

{-
-- use any string as an attribute/operation, hoping that it has
-- been defined somewhere using a let-expression
-- (no type checking here...)

    useLetDef _ _ name obj args = mkQuery obj name.s args;
    useLetArgNil = argNil; -- {s = ""; isNil = True};
    useLetArgCons c = argCons; 

-}

};
