concrete coreOCL of core = open Prelude, externalOperOCL, myTypesOCL, precedenceOCL in {

--# -path=.:prelude

lincat
    Class = ClassL;
    Constraint = ConstraintL;
    Constraints = ConstraintL;
    ConstraintHideContext = ConstraintL;
    Document = DocumentL;
    Instance = Inst;
    InstNoType = Inst;
    Sent = Inst;
    AtomSent = Inst;
    AndList = Inst;
    OrList = Inst;
    SumList = Inst;
    ProductList = Inst;
    LetDef = LetDefL;
    LetDefSent = LetDefL;
    LetDefList = LetDefListL;
    InstIter = {s1, s2, s3 : Str};
    SentIter = {s1, s2, s3 : Str};


--
-- Properties
-- 
    SimpleProperty = PropL;
    BooleanProperty = PropL;
    OnProperty = PropL;
    IsProperty = PropL;
    StaticProperty = PropL;
    AssocProperty = PropL;


--
-- Sent (should be the same as Instance)
--

lin eq _ = infix eqP "=";
	neq _ = infix eqP "<>";

	negAtom a = prefix unP "not" a;
	posAtom a = a;
	
--
-- self, result 
--
lin
	self _ _ = const "self";
	result _ _ = const "result";
	

--
-- let-definitions
--
lin letSimpleProperty rec ret prop definiens = letNoArg rec prop definiens;
    letOnProperty rec ret prop definiens = letNoArg rec prop definiens;

    letBooleanProperty = letNoArg;
    letIsProperty = letNoArg;
    
    letAddArg c d boundLetDef = boundLetDef;
    letAddArgSent c boundLetDefSent = boundLetDefSent;

    typeFormalParam clss exp = const ((inst2str exp) ++ ":" ++ clss.s);
    
--     defC c letdef list = ss ("def:" ++ "let" ++ letdef.s0 ++ ":" ++ c.s ++ "=" ++ letdef.s1);
--     defCSent letdef list = ss ("def:" ++ "let" ++ letdef.s0 ++ ":" ++ "Boolean" ++ "=" ++ letdef.s1);
    -- LetDefListL = {s : Bool => Str}; -- each elem in list should be preceeded by either "def:" or "let"
    nilLet = {s = ""; size = E0};
    consLet c ld lds = {
        s = ld.s0 ++ ":" ++ c.s ++ "=" ++ ld.s1 ++ case lds.size of {
            E0 => "";
            _ => "," ++ lds.s
        };
        size = eNext lds.size
    };
    consLetSent ld lds = {
        s = ld.s0 ++ ":" ++ "Boolean" ++ "=" ++ ld.s1 ++ case lds.size of {
            E0 => "";
            _ => "," ++ lds.s
        };
        size = eNext lds.size
    };
    
    localLet lds sent = const ("let" ++ lds.s ++ "in" ++ inst2str sent);

lin dropType _ i = i;
-- should we have ["@ pre"] instead of "@pre"?
lin atPre _ i = {s0 = i.s0; s1 = i.s1; p = i.p; isAtpre = True};
printname atPre = "@pre";
lin atPreSent i = {s0 = i.s0; s1 = i.s1; p = i.p; isAtpre = True};
--
-- Subtyping 
--
lin coerce sub super proof obj = obj;
pattern	subTypeRefl c = ["by reflexitivity,"] ++ c ++ ["is a subtype of itself"];
	subTypeTrans a b c proofab proofbc = ["by transitivity,"] ++ a++ ["is a subtype of"] ++
		c ++ ["since"] ++ b ++ ["is a subtype of"] ++ c ++ ["and"] ++ a ++["is a subtype of"] ++ b;

printname coerce = "[upcast]";


--
-- pre- and postconditions
--
lin
	emptyClassC = ss "";
	emptyOperC = ss "";
	emptyPostC = const "true";
	defC c ld list = ss ("def:" ++ ld.s0 ++ ":" ++ c.s ++ "=" ++ ld.s1 ++ list.s);
	defSentC ld list = ss ("def:" ++ ld.s0 ++ ":" ++ "Boolean" ++ "=" ++ ld.s1 ++ list.s);
	preC cond list = ss ("pre:" ++ inst2str cond ++ list.s);
	postC cond list = ss ("post:" ++ inst2str cond ++ list.s);
	prepostCt precond postcond = ss ("pre:" ++ inst2str precond ++ "post:" ++ inst2str postcond);
	invC cond list = ss ("inv:" ++ inst2str cond ++ list.s);
	invCt cond = ss ("inv:" ++ inst2str cond);
	
	invHC cond = ss (inst2str cond);


--
-- list of constraints
-- 

lin 
    oneConstraint c = c;
    consConstraint c cs = {s = c.s ++ "\\n" ++ cs.s};
    document cs = cs;

--
-- Properties
--
    useSimpleProperty _ _ prop obj = applyProp prop obj;
    useSimplePropertyImplicit _ _ prop obj = applyProp prop obj;
    useBooleanProperty _ prop obj = applyProp prop obj;
    useBooleanPropertyImplicit _ prop obj = applyProp prop obj;
    useOnProperty _ _ prop obj = applyProp prop obj;
    useOnPropertyImplicit _ _ prop obj = applyProp prop obj;
    useIsProperty _ prop obj = applyProp prop obj;
    useIsPropertyImplicit _ prop obj = applyProp prop obj;
    useStaticProperty _ _ prop obj = applyProp prop obj;
    useStaticPropertyImplicit _ _ prop obj = applyProp prop obj;    
    useAssocProperty _ _ prop obj = applyProp prop obj;
    useAssocPropertyImplicit _ _ prop obj = applyProp prop obj;

    	
};
